

/*
* Threshold_Adapt.h constains the API declarations for Threshold_Adapt.
*/

#ifndef THRESHOLD_ADAPT_H
#define THRESHOLD_ADAPT_H

#include <limits.h>
#include <math.h>
#include <time.h>
//#include "r_tree.h"
#include "dataUtility.h"
#include <string.h>

#ifdef WIN32
#include ".\IBFS\ibfs.h"
#include ".\BK\instances.h"

/*
#include ".\DF\values.h"
#include ".\DF\types_df.h"
#include ".\DF\parser_fl.c"
#include ".\DF\timer.c"
#include ".\DF\df.c"
*/

#else 
#include "./IBFS/ibfs.h"
#include "./BK/instances.h"
/*
#include "./DF/values.h"
#include "./DF/types_df.h"
#include "./DF/parser_fl.c"
#include "./DF/timer.c"
#include "./DF/df.c"
*/
#endif



//The structure of point.
typedef struct _point					
{
	//float* ord;
	float* ord;		//[DIM]

} _point_t;



/*The structure for storing the configuration info.
typedef struct config
{
	int  dim;

	int  p_objs_num;
	int  o_objs_num;

	char p_objs_file[MAX_FILENAME_LENG];
	char o_objs_file[MAX_FILENAME_LENG];

	char matching_result[MAX_FILENAME_LENG];
	char stat_file[MAX_FILENAME_LENG];
} config_t;
*/

#ifndef WIN32

extern struct rusage preprocess_start;
extern struct rusage preprocess_end;
extern struct rusage match_end;

#endif

/*The structure for storing the statistic info.
typedef struct stat
{
	//time.
	float	pre_t;
	float	match_t;
	float	total_t;

	//memory.
	float	memory_v;
	float	memory_max;
	
	//augmenting path.
	float	n_path;
	//float	path_length_max;
	float	path_length_sum;
	
	//queue.
	float	que_length_max;		
	float	que_length_sum;

	//expression.				
	//float	expension_max;
	//float	expension_sum;

} stat_t;
*/

//FordFulkerson related data structures and APIs.(Algorithm 1)
extern int** graph;				//The matrix structure of graph.
extern int** f;					//The flow information of network.

extern int*  prev;				//The augmenting path infomation.
extern int*  queue;				//Used for the BFS.

//BiPartite Matching--ford_fulkerson_bi related data structures and APIs.(Algorithm 2)
extern int** bGraph;			//Same to graph.
extern int** bf;				//Same to f.

extern int*  bPrev;				//The path information.
extern int*  bQueue;			//The queue used for bfs.
extern int*  bTag;				//Identification(P or O) of elements in bQueue.
extern int*  pLink;				//The 'link num' of set P.
extern int*  oLink;				//The 'link num' of Set O.
extern int*  pWeight;
extern int*  oWeight;

//Structures for storing the distance information.
extern DOUBLE** dist;			//2th Array to store the distance information.
extern DOUBLE*  distArray;		//The distance array (To be sorted).

//Structures for storing the input information (For Algorithm 1 & 2).
extern _point_t*	pPoint;			//Points set of p.
extern int*			pCapacity;		//Capacity set of p.
extern _point_t*	oPoint;			//Points set of O.
extern int*			oCapacity;
extern int			pSize, oSize, p_w_sum, o_w_sum;
//extern int			edge_n;


//Configuration info.
extern _config_t _cfg;

//Statistic info.
extern stat_t thr_stat_v;


/*
 *	Used for qsort.
 */
int DOUBLE_comparison(const void * a, const void * b);

//Maximal-flow algorithms.
//-----------------------------------------------------------

int find_path_gen( );		//----Potential strategies to speed up(Simulate the process).

int ford_fulkerson_gen( );

void test_ford_fulkerson( );

void ford_fulkerson_bi( );	//Used for unweighted oPoints.

//void  TestGenMatching( );

//
//-----------------------------------------------------------

//int partition( DOUBLE* d, int p1, int p2);

//void quick_sort( DOUBLE* d, int p1, int p2);

void flow_network_ini( DOUBLE cri);

void flow_network_ini_inc( DOUBLE cri, int change_tag);

bool max_flow_pruning( );

//void PreProcess_Sub5( );

void max_flow_pre_matching( );

DOUBLE TA_calc_dist( const float* ord1, const float* ord2);

void comp_dist_matrix( );

//IBFS
int IBFS( );

//BK
int BK( );


bool comp_max_flow( int alg_opt, int speed_opt, DOUBLE cri, int change_tag);

DOUBLE Threshold_Adapt( int alg_opt, int speed_opt);

//-----------------------------------------------------------

void TA_read_config( );

void TA_read_data( );

void TA_data_alloc( );

void TA_data_release( );

void emp_Threshold_Adapt( );


#endif
