
/*
 * dataUtility.h contains preprocessing utilities for the source data for the SPM-MM problem.
 *
 */

#ifndef DATAUTILITY_H
#define	DATAUTILITY_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>

#ifndef	WIN32
#include <sys/resource.h>
#endif


#include "irtree.h"

//#include "dataStruct.h"
//#include "Threshold_Adapt.h"
//#include "Swap_Chain.h"

//typedef	float	FLOAT;
//typedef	double  DOUBLE;

#define	FLOAT	float
#define DOUBLE	double

#define		D_CONFIG_FILE			"d_config.txt"

//#ifndef WIN32
#define		EMP_CONFIG_FILE			"config.txt"
//#else
//#define		EMP_CONFIG_FILE			"win_config.txt"
//#endif

#define		STATISTIC_FILE			"stat.txt"

#define		MAX_FILENAME_LENG		256
#define		MAX_DESCRIPTION_LENG	256
#define		TEXT_COL_MAX			1075

#define		MEMORY_SCALE			(1024*1024)

#define		PERTUBATION_TAG				0
#define		PERTUBATION_INTERVAL_LEFT	-100000
#define		PERTUBATION_INTERVAL_RIGHT	100000

#define		DISCRITITIZE_TAG		0
#define		DISCRITITIZE_SCALE		100


/*
//These two structures have been removed to itree.h.
typedef struct obj		//object structure.			
{
	//int dim;					//Dimension.
	FLOAT*	 axis;				//Coordinates.
	FLOAT	 weight;			//Weight: service capacity/demand.
} obj_t;

typedef struct data		//input data structure.
{
	int		dim;					//Dimension of data object.
	int		n_p_objs;				//The # of objects in P.
	int		n_o_objs;				//The # of objects in O.

	obj_t*	p_objs;				//The array containing P objects.
	obj_t*	o_objs;				//The array containing O objects.

}	data_t;
*/

/**/
typedef struct d_config	
{
	int dim;
/*	int n_p_obj;
	int n_o_obj;*/
	int w_combined;						//Tag: 1 for combined; otherwise 0.
	char p_obj[MAX_FILENAME_LENG];
	char o_obj[MAX_FILENAME_LENG];
	char p_weight[MAX_FILENAME_LENG];
	char o_weight[MAX_FILENAME_LENG];

	char matching[MAX_FILENAME_LENG];
	char stat_file[MAX_FILENAME_LENG];

}	d_config_t;

/**/
typedef struct _config
{
	int		dim;

	int		n_p;
	int		n_o;

	float	n_r;
	float	w_r;

	int		thr_opt;	//indicator for the threshold-adapt algorithm.
	int		speed_opt;

	int		swap_opt;	//indicator for the swap-chain algorithm.
	int		graph_tag;

	char	p_file[ MAX_FILENAME_LENG];
	char	o_file[ MAX_FILENAME_LENG];

}	_config_t;

//The structure for storing the info in form of "min, max, average".
typedef struct triplet
{
	float min;
	float max;
	float aver;

}	triplet_t;

//The structure storing the stactistc info.
typedef struct stat
{
	float	preprocess_time;
	float	matching_time;
	float	total_time;

	float	memory_max;			//The maximum memory it would cost--in terms of Byte.
	float	memory_v;			//The variable maintaining the dynamic memory cost--in terms of Byte.

	//Part I: specific variables for Threshold-Adapt.
	float	n_path;
	float	path_length_sum;
	float	path_length_aver;		
	
	//queue.
	float	que_length_max;		
	float	que_length_sum;
	float	que_length_aver;

	//Part II: specific variables for Swapping_Chain algorithms.
	float		n_reduction;		//The number of reductions of mmd value.
	triplet_t	n_swap;				//The number of swapping chains for each reduction.
	float		n_swap_sum;	

	triplet_t	n_swap_que;			//queue.
	float		n_swap_que_sum;

	triplet_t	n_expension;		//
	float		n_expension_sum;

	float	n_ini_edge;				//edge.
	float	n_prev_edge;
	float	n_edge_sum;
	float	n_edge_aver;

	//stat_t	n_pair;
	float	n_pair_v;				//pair.
	float	n_ini_pair;
	float	n_pair_max;


	//
	float	R_tree_build_time;

}	stat_t;


#ifndef WIN32

void get_cur_time( struct rusage* curTime);

void collect_time( struct rusage* timeStart, struct rusage* timeEnd, float* userTime, float* sysTime);

#endif



//Query & dataset generation utilities.
int rand_i( int min, int max);

double rand_f( double min_v, double max_v);

bool is_old( float* rand_v, int cur, float var);


//-----------------------------

d_config_t* dReadConfig( );

data_t* dReadData( d_config_t* d_cfg);

//-----------------------------

_config_t* emp_read_config( );

data_t*	emp_read_data( _config_t* cfg);

void data_release( data_t* dat);

void print_stat( DOUBLE mmd, stat_t stat_v);



//Updated on 27 Feb.
//-----------------------------



#endif
