
#include "synDataPreProcess.h"
#include "Swap_Chain.h"
#include "Threshold_Adapt.h"

#include "irtree.h"


//Part I: Global variables for Threshold-Adapt.
//Maximum Flow(Ford-Fulkerson) related globals--Algorithm 1.
int	**graph;			//The matrix structure of graph.
int	**f;				//The flow information of network.
int	*prev;				//The augmenting path infomation.
int	*queue;				//Used for the BFS.

//Maximum Flow(bFord-Fulkerson) related globals--Algorithm 2.
int **bGraph;			//Same to graph.
int **bf;				//Same to f.
int *bPrev;				//The path information.
int *bQueue;			//The queue used for bfs.
int *bTag;				//Identification(P or O) of elements in bQueue.
int *pLink;				//The 'link num' of set P.
int *oLink;				//The 'link num' of Set O.
int *pWeight;
int *oWeight;

//Structures for storing the distance information.
DOUBLE** dist;			//2th Array to store the distance information.
DOUBLE*  distArray;		//The distance array(To be sorted).

//Structures for storing the input information (For Algorithm 1 & 2).
_point_t*	pPoint;				//Points set of p.
int*		pCapacity;			//Capacity set of p.
_point_t*	oPoint;				//Points set of O.
int*	oCapacity;			
int		pSize, oSize, p_w_sum, o_w_sum;

//Configuration info.
_config_t _cfg;
stat_t thr_stat_v;



#ifndef WIN32

struct rusage preprocess_start;
struct rusage preprocess_end;
struct rusage match_end;

#endif


//Part II: Global variables for Swap-Chain.
R_tree_t	R_tree_v;
tree_stat_t	tree_stat_v;

//Statistic variables for collecting the info related to "Swapping_Chain".
stat_t swap_stat_v;


int graph_impl_tag;


#ifndef WIN32
struct rusage t_rTree_end;
#endif

int main()
{
	//Syn_Preprocess( );

	//Weight_Generator( );

	//Emp_Combine_Weight( );

	//Emp_Norm_Real( 0, 10000);
	
	//Combine_Weight( );



	//Save the constructed R-tree in the file specified in "config.txt".
	//test_R_tree( 1);

	//Save the constructed R-tree in stdout.
	//test_TRTree( 2);

	//printf( "Flow: %i \n", IBFS( ));

	_config_t* cfg;

	//printf( "Length of int: %i\n", sizeof( int));

	//printf( "Size of tcapacity: %i\n", sizeof( tcapacity));

	cfg = emp_read_config( );

	//
	graph_impl_tag = cfg->graph_tag;

	if( cfg->thr_opt == -1)
		emp_Swapping_Chain( );	//Swap-Chain.
	else
		emp_Threshold_Adapt( );		//Threshold-Adapt.

	free( cfg);

	return 0;
}
