/*
  This code was written by Xiaokui Xiao.
  Please read the following.

    Raymond Chi-Wing Wong, Yufei Tao, Ada Wai-Chee Fu and Xiaokui Xiao. 
    "On Efficient Spatial Matching", 
    the 33rd International Conference on Very Large Data Bases (VLDB'07), 
    Vienna, Austria on 23-28 Sept, 2007 

*/
#ifndef CLOSEST_PAIR_XXK_20070317
#define CLOSEST_PAIR_XXK_20070317

#include "rtree.h"

class XkPair
{
public:
	bool operator < ( const XkPair& rOtherPair ) const
	{
		return m_fDist < rOtherPair.m_fDist;
	}

	bool operator > ( const XkPair& rOtherPair ) const
	{
		return m_fDist > rOtherPair.m_fDist;
	}

public:
	node_type*	m_pNodeO;
	node_type*	m_pNodeP;
	float		m_fDist;
};


XkPair XkClosestPair( node_type* pRootO, node_type* pRootP, rtree_info* aInfoO, rtree_info* aInfoP );


#endif	//	CLOSEST_PAIR_XXK_20070317
