/*
  This code was written by Raymond Chi-Wing Wong.
  Please read the following.

    Raymond Chi-Wing Wong, Yufei Tao, Ada Wai-Chee Fu and Xiaokui Xiao. 
    "On Efficient Spatial Matching", 
    the 33rd International Conference on Very Large Data Bases (VLDB'07), 
    Vienna, Austria on 23-28 Sept, 2007 

*/

#ifndef CONFIG_H
#define CONFIG_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "rtree.h"
#include "point.h"

struct configure_s
{
	pointList *O;
	pointList *P;

	int ALG;

	char *oFilename;
	char *pFilename;

	config_type *rtreeConf;
	rtree_info *rtreeInfo;
};

typedef struct configure_s configure;

configure *readConfig(char *filename);

configure *configure_new();

#endif

